﻿// <auto-generated />
using System;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Migrations;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;
using Otus.Teaching.PromoCodeFactory.DataAccess;

namespace Otus.Teaching.PromoCodeFactory.DataAccess.Migrations
{
    [DbContext(typeof(DatabaseContext))]
    [Migration("20230401141113_Init")]
    partial class Init
    {
        protected override void BuildTargetModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasAnnotation("ProductVersion", "3.1.32");

            modelBuilder.Entity("Otus.Teaching.PromoCodeFactory.Core.Domain.Administration.Employee", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("TEXT");

                    b.Property<int>("AppliedPromocodesCount")
                        .HasColumnType("INTEGER");

                    b.Property<string>("Email")
                        .HasColumnType("TEXT");

                    b.Property<Guid>("EmployeeOfPromocodeId")
                        .HasColumnType("TEXT");

                    b.Property<string>("FirstName")
                        .HasColumnType("TEXT");

                    b.Property<string>("LastName")
                        .HasColumnType("TEXT");

                    b.HasKey("Id");

                    b.HasIndex("EmployeeOfPromocodeId")
                        .IsUnique();

                    b.ToTable("Employees");

                    b.HasData(
                        new
                        {
                            Id = new Guid("6d22e3d3-d006-41c0-9264-ae377de1fcda"),
                            AppliedPromocodesCount = 5,
                            Email = "owner@somemail.ru",
                            EmployeeOfPromocodeId = new Guid("297d8bf6-bd59-425d-a0f2-6ed13ee2d8bb"),
                            FirstName = "Иван",
                            LastName = "Сергеев"
                        },
                        new
                        {
                            Id = new Guid("12623d06-84ab-4df2-b7fb-6d5d00d185e9"),
                            AppliedPromocodesCount = 10,
                            Email = "andreev@somemail.ru",
                            EmployeeOfPromocodeId = new Guid("161a50ee-1d92-467f-9e30-91a6d8fa7a89"),
                            FirstName = "Петр",
                            LastName = "Андреев"
                        },
                        new
                        {
                            Id = new Guid("3cd51471-3c05-4cbb-ad5c-c847a9e395ea"),
                            AppliedPromocodesCount = 10,
                            Email = "andreev@somemail.ru",
                            EmployeeOfPromocodeId = new Guid("99645e48-f38d-43a2-9017-c5be4f89b3fb"),
                            FirstName = "Петр",
                            LastName = "Андреев"
                        });
                });

            modelBuilder.Entity("Otus.Teaching.PromoCodeFactory.Core.Domain.Administration.Role", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("TEXT");

                    b.Property<string>("Description")
                        .HasColumnType("TEXT");

                    b.Property<string>("Name")
                        .HasColumnType("TEXT");

                    b.Property<Guid>("RoleOfEmployeeId")
                        .HasColumnType("TEXT");

                    b.HasKey("Id");

                    b.HasIndex("RoleOfEmployeeId")
                        .IsUnique();

                    b.ToTable("Roles");

                    b.HasData(
                        new
                        {
                            Id = new Guid("53729686-a368-4eeb-8bfa-cc69b6050d02"),
                            Description = "Администратор",
                            Name = "Admin",
                            RoleOfEmployeeId = new Guid("6d22e3d3-d006-41c0-9264-ae377de1fcda")
                        },
                        new
                        {
                            Id = new Guid("b0ae7aac-5493-45cd-ad16-87426a5e7665"),
                            Description = "Партнерский менеджер",
                            Name = "PartnerManager",
                            RoleOfEmployeeId = new Guid("12623d06-84ab-4df2-b7fb-6d5d00d185e9")
                        });
                });

            modelBuilder.Entity("Otus.Teaching.PromoCodeFactory.Core.Domain.PromoCodeManagement.Customer", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("TEXT");

                    b.Property<string>("Email")
                        .HasColumnType("TEXT");

                    b.Property<string>("FirstName")
                        .HasColumnType("TEXT");

                    b.Property<string>("LastName")
                        .HasColumnType("TEXT");

                    b.HasKey("Id");

                    b.ToTable("Customers");

                    b.HasData(
                        new
                        {
                            Id = new Guid("a6c8c6b1-4349-45b0-ab31-244740aaf0f0"),
                            Email = "ivan_ivanov@mail.ru",
                            FirstName = "Иван",
                            LastName = "Иванов"
                        },
                        new
                        {
                            Id = new Guid("9b6314f1-ac41-47f0-bc41-383c55f13cb0"),
                            Email = "ivan_petrov@mail.ru",
                            FirstName = "Иван",
                            LastName = "Петров"
                        },
                        new
                        {
                            Id = new Guid("99c11c29-4d67-42e3-9fb8-8c834b0074b9"),
                            Email = "ivan_sidorov@mail.ru",
                            FirstName = "Иван",
                            LastName = "Сидоров"
                        });
                });

            modelBuilder.Entity("Otus.Teaching.PromoCodeFactory.Core.Domain.PromoCodeManagement.CustomerPreference", b =>
                {
                    b.Property<Guid>("CustomerId")
                        .HasColumnType("TEXT");

                    b.Property<Guid>("PreferenceId")
                        .HasColumnType("TEXT");

                    b.HasKey("CustomerId", "PreferenceId");

                    b.HasIndex("PreferenceId");

                    b.ToTable("CustomerPreferences");

                    b.HasData(
                        new
                        {
                            CustomerId = new Guid("a6c8c6b1-4349-45b0-ab31-244740aaf0f0"),
                            PreferenceId = new Guid("00a56946-9f55-4102-b435-641347685bac")
                        },
                        new
                        {
                            CustomerId = new Guid("9b6314f1-ac41-47f0-bc41-383c55f13cb0"),
                            PreferenceId = new Guid("0cc79168-d082-44c3-831a-36cff2038df0")
                        },
                        new
                        {
                            CustomerId = new Guid("99c11c29-4d67-42e3-9fb8-8c834b0074b9"),
                            PreferenceId = new Guid("7471c92c-8391-4ec8-9abe-5eadf5a96dc2")
                        });
                });

            modelBuilder.Entity("Otus.Teaching.PromoCodeFactory.Core.Domain.PromoCodeManagement.Preference", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("TEXT");

                    b.Property<string>("Name")
                        .HasColumnType("TEXT");

                    b.Property<Guid>("PreferenceOfPromocodeId")
                        .HasColumnType("TEXT");

                    b.HasKey("Id");

                    b.HasIndex("PreferenceOfPromocodeId")
                        .IsUnique();

                    b.ToTable("Preferences");

                    b.HasData(
                        new
                        {
                            Id = new Guid("00a56946-9f55-4102-b435-641347685bac"),
                            Name = "Театр",
                            PreferenceOfPromocodeId = new Guid("297d8bf6-bd59-425d-a0f2-6ed13ee2d8bb")
                        },
                        new
                        {
                            Id = new Guid("0cc79168-d082-44c3-831a-36cff2038df0"),
                            Name = "Семья",
                            PreferenceOfPromocodeId = new Guid("161a50ee-1d92-467f-9e30-91a6d8fa7a89")
                        },
                        new
                        {
                            Id = new Guid("7471c92c-8391-4ec8-9abe-5eadf5a96dc2"),
                            Name = "Дети",
                            PreferenceOfPromocodeId = new Guid("99645e48-f38d-43a2-9017-c5be4f89b3fb")
                        });
                });

            modelBuilder.Entity("Otus.Teaching.PromoCodeFactory.Core.Domain.PromoCodeManagement.PromoCode", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("TEXT");

                    b.Property<DateTime>("BeginDate")
                        .HasColumnType("TEXT");

                    b.Property<string>("Code")
                        .HasColumnType("TEXT");

                    b.Property<Guid>("CurrentCustomerId")
                        .HasColumnType("TEXT");

                    b.Property<DateTime>("EndDate")
                        .HasColumnType("TEXT");

                    b.Property<string>("PartnerName")
                        .HasColumnType("TEXT");

                    b.Property<string>("ServiceInfo")
                        .HasColumnType("TEXT");

                    b.HasKey("Id");

                    b.HasIndex("CurrentCustomerId");

                    b.ToTable("Promocodes");

                    b.HasData(
                        new
                        {
                            Id = new Guid("297d8bf6-bd59-425d-a0f2-6ed13ee2d8bb"),
                            BeginDate = new DateTime(2022, 5, 1, 17, 34, 42, 0, DateTimeKind.Local),
                            Code = "Code1",
                            CurrentCustomerId = new Guid("a6c8c6b1-4349-45b0-ab31-244740aaf0f0"),
                            EndDate = new DateTime(2035, 5, 1, 17, 34, 42, 0, DateTimeKind.Local),
                            PartnerName = "PartnerName1",
                            ServiceInfo = "ServiceInfo1"
                        },
                        new
                        {
                            Id = new Guid("161a50ee-1d92-467f-9e30-91a6d8fa7a89"),
                            BeginDate = new DateTime(2022, 5, 1, 17, 34, 42, 0, DateTimeKind.Local),
                            Code = "Code2",
                            CurrentCustomerId = new Guid("a6c8c6b1-4349-45b0-ab31-244740aaf0f0"),
                            EndDate = new DateTime(2035, 5, 1, 17, 34, 42, 0, DateTimeKind.Local),
                            PartnerName = "PartnerName2",
                            ServiceInfo = "ServiceInfo2"
                        },
                        new
                        {
                            Id = new Guid("99645e48-f38d-43a2-9017-c5be4f89b3fb"),
                            BeginDate = new DateTime(2022, 5, 1, 17, 34, 42, 0, DateTimeKind.Local),
                            Code = "Code3",
                            CurrentCustomerId = new Guid("a6c8c6b1-4349-45b0-ab31-244740aaf0f0"),
                            EndDate = new DateTime(2035, 5, 1, 17, 34, 42, 0, DateTimeKind.Local),
                            PartnerName = "PartnerName3",
                            ServiceInfo = "ServiceInfo3"
                        });
                });

            modelBuilder.Entity("Otus.Teaching.PromoCodeFactory.Core.Domain.Administration.Employee", b =>
                {
                    b.HasOne("Otus.Teaching.PromoCodeFactory.Core.Domain.PromoCodeManagement.PromoCode", "Promocode")
                        .WithOne("PartnerManager")
                        .HasForeignKey("Otus.Teaching.PromoCodeFactory.Core.Domain.Administration.Employee", "EmployeeOfPromocodeId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();
                });

            modelBuilder.Entity("Otus.Teaching.PromoCodeFactory.Core.Domain.Administration.Role", b =>
                {
                    b.HasOne("Otus.Teaching.PromoCodeFactory.Core.Domain.Administration.Employee", "Employee")
                        .WithOne("Role")
                        .HasForeignKey("Otus.Teaching.PromoCodeFactory.Core.Domain.Administration.Role", "RoleOfEmployeeId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();
                });

            modelBuilder.Entity("Otus.Teaching.PromoCodeFactory.Core.Domain.PromoCodeManagement.CustomerPreference", b =>
                {
                    b.HasOne("Otus.Teaching.PromoCodeFactory.Core.Domain.PromoCodeManagement.Customer", "Customer")
                        .WithMany("CustomerPreferences")
                        .HasForeignKey("CustomerId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("Otus.Teaching.PromoCodeFactory.Core.Domain.PromoCodeManagement.Preference", "Preference")
                        .WithMany("CustomerPreferences")
                        .HasForeignKey("PreferenceId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();
                });

            modelBuilder.Entity("Otus.Teaching.PromoCodeFactory.Core.Domain.PromoCodeManagement.Preference", b =>
                {
                    b.HasOne("Otus.Teaching.PromoCodeFactory.Core.Domain.PromoCodeManagement.PromoCode", "Promocode")
                        .WithOne("Preference")
                        .HasForeignKey("Otus.Teaching.PromoCodeFactory.Core.Domain.PromoCodeManagement.Preference", "PreferenceOfPromocodeId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();
                });

            modelBuilder.Entity("Otus.Teaching.PromoCodeFactory.Core.Domain.PromoCodeManagement.PromoCode", b =>
                {
                    b.HasOne("Otus.Teaching.PromoCodeFactory.Core.Domain.PromoCodeManagement.Customer", "Customer")
                        .WithMany("Promocodes")
                        .HasForeignKey("CurrentCustomerId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();
                });
#pragma warning restore 612, 618
        }
    }
}
